const uri = require('./uriGenerators');
const autoBind = require('../../util/autobind');

/**
 * FrequencyRules
 */
class FrequencyRules {
  constructor(http) {
    this.http = http;
    autoBind(this);
  }

  /**
   * @param {string} directoryId
   * @param {Object} bodyParams
   * @return {Promise}
   */
  createContactFrequencyRule(directoryId, bodyParams) {
    return this.http.post(uri._frequencyRulesUri(directoryId, ''), bodyParams);
  }

  /**
   * @param {string} directoryId
   * @param {Object} queryParams
   * @return {Promise}
   */
  listContactFrequencyRules(directoryId, queryParams) {
    return this.http.get(uri._frequencyRulesUri(directoryId, ''), queryParams);
  }

  /**
   * @param {string} directoryId
   * @param {string} ruleId
   * @return {Promise}
   */
  getFrequencyRule(directoryId, ruleId) {
    return this.http.get(uri._frequencyRulesUri(directoryId, ruleId));
  }
}

module.exports = FrequencyRules;
