module.exports = {
  _directoriesUri,
  _contactsUri,
  _incentivePointsUri,
  _mailingListsUri,
  _mailingListsContactsUri,
  _mailingListsContactsHistoryUri,
  _contactsTransactionsUri,
  _directoryTransactionsUri,
  _transactionBatchesUri,
  _transactionBatchesTransactionUri,
  _transactionContactsUri,
  _contactsHistoryUri,
  _samplesUri,
  _samplesContactsUri,
  _samplesProgressUri,
  _samplesDefinitionsUri,
  _frequencyRulesUri,
};

function _directoriesUri(directoryId = '') {
  return `/directories/${directoryId}`;
}

function _contactsUri(directoryId, contactId = '') {
  return `${_directoriesUri(directoryId)}/contacts/${contactId}`;
}

function _incentivePointsUri(directoryId, contactId = '') {
  return `${_directoriesUri(directoryId)}/contacts/${contactId}/incentivepoints`;
}

function _mailingListsUri(directoryId, mailingListId = '') {
  return `${_directoriesUri(directoryId)}/mailinglists/${mailingListId}`;
}

function _mailingListsContactsUri(directoryId, mailingListId, contactId = '') {
  return `${_mailingListsUri(directoryId, mailingListId)}/contacts/${contactId}`;
}

function _mailingListsContactsHistoryUri(directoryId, mailingListId, contactId = '') {
  return `${_mailingListsUri(directoryId, mailingListId)}/contacts/${contactId}/history`;
}

function _contactsTransactionsUri(directoryId, contactId, transactionId = '') {
  return `${_contactsUri(directoryId, contactId)}/transactions/${transactionId}`;
}

function _directoryTransactionsUri(directoryId, transactionId = '') {
  return `${_directoriesUri(directoryId)}/transactions/${transactionId}`;
}

function _transactionBatchesUri(directoryId, batchId = '') {
  return `${_directoriesUri(directoryId)}/transactionbatches/${batchId}`;
}

function _transactionBatchesTransactionUri(directoryId, batchId, transactionId = '') {
  return `${_transactionBatchesUri(directoryId, batchId)}/transactions/${transactionId}`;
}

function _transactionContactsUri(directoryId, mailingListId, importId = '') {
  return `${_mailingListsUri(directoryId, mailingListId)}/transactioncontacts/${importId}`;
}

function _contactsHistoryUri(directoryId, contactId) {
  return `${_directoriesUri(directoryId)}/contacts/${contactId}/history`;
}

function _samplesUri(directoryId, sampleId = '') {
  return `${_directoriesUri(directoryId)}/samples/${sampleId}`;
}

function _samplesContactsUri(directoryId, sampleId = '') {
  return `${_directoriesUri(directoryId)}/samples/${sampleId}/contacts`;
}

function _samplesProgressUri(directoryId, progressId = '') {
  return `${_directoriesUri(directoryId)}/samples/progress/${progressId}`;
}

function _samplesDefinitionsUri(directoryId, sampleDefinitionId = '') {
  return `${_directoriesUri(directoryId)}/samples/definitions/${sampleDefinitionId}`;
}

function _frequencyRulesUri(directoryId, ruleId = '') {
  return `${_directoriesUri(directoryId)}/frequencyrules/${ruleId}`;
}
