const autoBind = require('../util/autobind');

/**
 * Divisions
 */
class Divisions {
  constructor(http) {
    this.http = http;
    autoBind(this);
  }

  /**
   * @param  {Object} bodyParams
   * @return {Promise}
   */
  createDivision(bodyParams) {
    return this.http.post(_divisionsUri(), bodyParams);
  }

  /**
   * @param  {string} divisionId
   * @return {Promise}
   */
  getDivision(divisionId) {
    return this.http.get(_divisionsUri(divisionId));
  }

  /**
   * @param  {string} divisionId
   * @param  {Object} bodyParams
   * @return {Promise}
   */
  updateDivision(divisionId, bodyParams) {
    return this.http.put(_divisionsUri(divisionId), bodyParams);
  }
}

function _divisionsUri(divisionId = '') {
  return `/divisions/${divisionId}`;
}

module.exports = Divisions;
