const autoBind = require('../util/autobind');

/**
 * Responses
 */
class Responses {
  constructor(http) {
    this.http = http;
    autoBind(this);
  }

  /**
   * @param {string} responseId
   * @param {Object} bodyParams
   * @return {Promise}
   */
  updateResponse(responseId, bodyParams) {
    return this.http.put(_responsesUri(responseId), bodyParams);
  }

  /**
   * @param {string} responseId
   * @param {Object} queryParams
   * @return {Promise}
   */
  deleteResponse(responseId, queryParams) {
    return this.http.delete(_responsesUri(responseId), queryParams);
  }
}

function _responsesUri(responseId = '') {
  return `/responses/${responseId}`;
}

module.exports = Responses;
