class Config {
  constructor({dataCenter, apiToken}) {
    this._dataCenter = dataCenter;
    this._apiToken = apiToken;
  }

  get apiToken() {
    if (!this._apiToken) {
      throw new Error('Missing API token');
    }
    return this._apiToken;
  }

  set apiToken(_apiToken) {
    this._apiToken = _apiToken;
  }

  get dataCenter() {
    if (!this._dataCenter) {
      throw new Error('Missing data center');
    }
    return this._dataCenter;
  }

  set dataCenter(_dataCenter) {
    this._dataCenter = _dataCenter;
  }

  get baseUrl() {
    return `https://${this._dataCenter}.qualtrics.com/API/v3`;
  }
}

module.exports = Config;
