const fs = require('fs');
const promisify = require('./promisify');

module.exports = parseJsonFile;

const readFile = promisify(fs.readFile);

function parseJsonFile(filePath) {
  return readFile(filePath)
    .then((buffer) => {
      try {
        return JSON.parse(buffer);
      } catch (error) {
        return buffer;
      }
    });
}
