module.exports = pollUntilFinished;

function pollUntilFinished(id, progressFn, delay = 3000) {
  return progressFn(id)
    .then((response) => {
      if (response && response.result && response.result.percentComplete === 100) {
        return id;
      } else if (response && response.result && response.result.status === 'failure') {
        throw response;
      } else {
        return new Promise((resolve, reject) => {
          setTimeout(() => {
            pollUntilFinished(id, progressFn).then(resolve).catch(reject);
          }, delay);
        });
      }
    });
}
