module.exports = promisify;

function promisify(fn) {
  return (...args) => {
    return new Promise((resolve, reject) => {
      fn(...args, (error, result) => {
        error ? reject(error) : resolve(result);
      });
    });
  };
}
