const fs = require('fs');
const path = require('path');
const unzip = require('unzip');

module.exports = unzipFile;

function unzipFile(zipFilePath) {
  const directory = path.dirname(zipFilePath);
  const readStream = fs.createReadStream(zipFilePath);
  const unzipStream = readStream.pipe(unzip.Parse()); // eslint-disable-line
  return new Promise((resolve, reject) => {
    readStream.on('error', reject);
    unzipStream
      .on('error', reject)
      .on('entry', (entry) => {
        const destinationPath = path.join(directory, entry.path);
        const writeStream = entry.pipe(fs.createWriteStream(destinationPath));
        writeStream
          .on('error', reject)
          .on('close', () => resolve(destinationPath));
      });
  });
}
